Bug 28694 - Check alert in cataloguing should be a static message
Summary: Check alert in cataloguing should be a static message
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Cataloging (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Bugs List
QA Contact: Testopia
URL:
Keywords:
Depends on: 27526
Blocks: 29585 30159 30224
  Show dependency treegraph
 
Reported: 2021-07-08 17:32 UTC by Tomás Cohen Arazi
Modified: 2022-04-22 12:40 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Documentation contact:
Documentation submission:
Text to go in the release notes:
This patch changes the way error form validation error messages are displayed when using the basic MARC editor in cataloging. Instead of a JavaScript alert, errors are now shown on the page itself, with links in the message to take you to the corresponding field. A new "Errors" button in the toolbar allows the user to jump back to the list of errors for easy reference.
Version(s) released in:
21.11.00


Attachments
Bug 28694: Check alert in cataloguing should be a static message (14.90 KB, patch)
2021-10-08 16:48 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 28694: Check alert in cataloguing should be a static message (14.95 KB, patch)
2021-10-10 20:13 UTC, David Nind
Details | Diff | Splinter Review
Bug 28694: Check alert in cataloguing should be a static message (15.03 KB, patch)
2021-10-30 23:53 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Tomás Cohen Arazi 2021-07-08 17:32:14 UTC
Just that. The current 'alert' approach is inconsistent with the rest of the UI.
Comment 1 Victor Grousset/tuxayo 2021-07-08 18:28:50 UTC
The alert when one forgets a mandatory field?
Comment 2 Tomás Cohen Arazi 2021-07-08 18:33:32 UTC
(In reply to Victor Grousset/tuxayo from comment #1)
> The alert when one forgets a mandatory field?

Yes! For *st sake!
Comment 3 Victor Grousset/tuxayo 2021-07-08 19:42:42 UTC
indeed lol ^^
Comment 4 Owen Leonard 2021-07-15 11:52:34 UTC
The bug title says "modal" but I'm not sure that's what's really being asked for. Here's what it might look like as a modal:

https://snipboard.io/yb48VR.jpg
Comment 5 Jonathan Druart 2021-07-15 13:53:07 UTC
Shouldn't it be displayed on the cataloguing screen?

I mean, if you get this "popup" with dozen of entries, you will have to hit save again to trigger the error list as it's not possible to remember what it contains (maybe cataloguers can? I am just a developer).
Comment 6 Owen Leonard 2021-07-15 13:55:40 UTC
I think that's a valid concern, and I would mitigate it by adding a button for redisplaying the message after it has been closed like we do on the checkin page.

But it probably makes more sense to make it static, despite the bug title asking for modal.
Comment 7 Jonathan Druart 2021-07-15 13:59:34 UTC
Hum, that will make it harder to integrate with the different forms (add item forms in mind).
Comment 8 Victor Grousset/tuxayo 2021-07-15 18:53:54 UTC
> Shouldn't it be displayed on the cataloguing screen?

Like a yellow message above like those who are used for error on holds?


> harder to integrate with the different forms (add item forms in mind).

The record cataloguing errors are used in the add item forms?
Comment 9 Owen Leonard 2021-10-08 16:48:19 UTC Comment hidden (obsolete)
Comment 10 David Nind 2021-10-10 20:13:55 UTC Comment hidden (obsolete)
Comment 11 Katrin Fischer 2021-10-30 23:52:49 UTC
I really like this new workflow for resolving the errors with the ability to jump to fields and errors!
Comment 12 Katrin Fischer 2021-10-30 23:53:18 UTC
Created attachment 127113 [details] [review]
Bug 28694: Check alert in cataloguing should be a static message

This patch modifies the basic cataloging interface so that form
validation errors are collected in a static "dialog" at the top of the
page instead of showing in a transient JavaScript alert.

The text of the message is roughly the same as it was in the alert, and
links have been added so that the user can click to jump directly to the
field referenced.

If the user scrolls down away from the static error message, a button
appears in the floating toolbar to jump back to the message.

To test, apply the patch and rebuild the staff interface CSS
(https://wiki.koha-community.org/wiki/Working_with_SCSS_in_the_OPAC_and_staff_client).

- Go to Cataloging and create a new record using the basic cataloging
  editor and a framework which has multiple mandatory fields defined
  (e.g. an unmodified default framework)
- Without entering anything in mandatory fields, click the "Save"
  button.
- You should see a message box appear at the top of the page.
  - It should list each missing mandatory subfield and tag, each with a
    "Go to field" link next to it.
  - Clicking the "Go to field" link should switch you to the correct tab
    and scroll the mandatory field into view.
- When you have scrolled down far enough for the error messages to be
  offscreen, an "Errors" button should appear in the floating toolbar.
  Clicking it should scroll the box back into view.
- The JS function for scrolling to a particular element on the screen
  has been modified, so test that the links in the toolbar for
  individual tags still work correctly.

Signed-off-by: David Nind <david@davidnind.com>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 13 Katrin Fischer 2021-10-31 00:04:27 UTC
I wonder if we could improve on the bug description a little to point out that this is also a usability enhancement. At the moment it's correct, but doesn't paint a clear picture.
Comment 14 Jonathan Druart 2021-11-03 14:31:19 UTC
Pushed to master for 21.11, thanks to everybody involved!
Comment 15 Katrin Fischer 2021-12-19 13:32:01 UTC
Just noticed in testing that it would be nice to have these changes for the authority editor as well:
Bug 29732 - Check alert in cataloguing authorities should be a static message